# Copyright (C) 2022 Wind River Systems, Inc.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
from docs_conf.conf import *

linkcheck_ignore = [
    'http://localhost.*',
    'http://127.0.0.1.*',
    'https://gerrit.o-ran-sc.org.*',
    'http://put_your_*',
    './oran-o2-api.html',  # Generated file that doesn't exist at link check.
    './api-docs.html'
]

extensions = ['sphinxcontrib.redoc', 'sphinx.ext.intersphinx']

redoc = [
    {
        'name': 'O-RAN O2 API',
                'page': 'oran-o2-api',
                'spec': './swagger.json',
                'embed': True,
    }
]

redoc_uri = 'https://cdn.jsdelivr.net/npm/redoc@next/bundles/redoc.standalone.js'

# intershpinx mapping with other projects
# intersphinx_mapping = {}
