# Copyright (C) 2021 Wind River Systems, Inc.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import json
from dataclasses import asdict
import redis

from o2common.config import config
from o2common.domain import events

from o2common.helper import o2logging
logger = o2logging.get_logger(__name__)


r = redis.Redis(**config.get_redis_host_and_port())


def publish(channel, event: events.Event):
    logger.info("publishing: channel=%s, event=%s", channel, event)
    r.publish(channel, json.dumps(asdict(event), default=str))
